//----------------------------------------------------------------------//
// NyanFi																//
//  TlC擾Xbh												//
//----------------------------------------------------------------------//
#ifndef ThumbnailThreadH
#define ThumbnailThreadH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
class TThumbnailThread : public TThread
{
private:
	TMultiReadExclusiveWriteSynchronizer *TaskRWLock;

	bool FReqClear;
	bool __fastcall GetReqClear();
	void __fastcall SetReqClear(bool Value);

	bool FReqStart;
	bool __fastcall GetReqStart();
	void __fastcall SetReqStart(bool Value);

	bool FReqMake;
	bool __fastcall GetReqMake();
	void __fastcall SetReqMake(bool Value);

	bool FIsEmpty;
	bool __fastcall GetIsEmpty();
	void __fastcall SetIsEmpty(bool Value);

	int  FCount;
	int  __fastcall GetCount();

	void __fastcall Execute();

public:
	HWND CallbackWnd;

	__property bool ReqClear = {read = GetReqClear, write = SetReqClear};	//Xg̃NAv
	__property bool ReqStart = {read = GetReqStart, write = SetReqStart};	//擾X^[gv
	__property bool ReqMake  = {read = GetReqMake,  write = SetReqMake};	//ʍ쐬v
	__property bool IsEmpty  = {read = GetIsEmpty,  write = SetIsEmpty};	//TlC擾
	__property int  Count    = {read = GetCount};							//Xgڐ

	int MakeIndex;

	TStringList *ThumbnailList;	//TlCXg
	UnicodeString __fastcall GetListItem(int idx);
	void          __fastcall SetListItem(int idx, UnicodeString s);
	Graphics::TBitmap* __fastcall GetListBitmap(int idx);

	__fastcall TThumbnailThread(bool CreateSuspended);
	bool __fastcall FitSize(int *wd, int *hi);
	void __fastcall MakeThumbnail(int idx);
};
//---------------------------------------------------------------------------
#endif
